package com.gyee.clientside.config;

import org.springframework.boot.system.ApplicationHome;
import org.springframework.stereotype.Component;

import java.io.File;

@Component
public class FilePathConfig {
    private static String filePath;
    private static String taosTemplatePath;

    public static String getFilePath() {
        if (filePath == null) {
            ApplicationHome home = new ApplicationHome(FilePathConfig.class);
            filePath = home.getSource().getParentFile().getAbsolutePath();
        }
        return filePath;
    }

    public static String getTaosInfoTablePath() {
        if (taosTemplatePath == null) {
            getFilePath();
            taosTemplatePath = filePath + File.separator + "Taos更新表.xlsx";
            File file = new File(taosTemplatePath);
            if (!file.exists()) file.mkdirs();
        }
        return taosTemplatePath;
    }
}
