package com.gyee.clientside.config;

import com.baomidou.mybatisplus.core.MybatisConfiguration;
import com.baomidou.mybatisplus.extension.spring.MybatisSqlSessionFactoryBean;
import org.apache.ibatis.logging.stdout.StdOutImpl;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

import javax.sql.DataSource;

@Configuration
@MapperScan(basePackages = "com.gyee.clientside.mapper.mydbinfo", sqlSessionFactoryRef = "mydbinfoSqlSessionFactory")
public class MydbinfoDSConfig {

    @Bean(name = "mydbinfo")
    @Primary
    @ConfigurationProperties("spring.datasource.druid.mydbinfo")
    public DataSource mydbinfoDataSource() {
        return DataSourceBuilder.create().build();
    }

    @Bean(name = "mydbinfoSqlSessionFactory")
    @Primary
    public SqlSessionFactory mydbinfoSqlSessionFactory(@Qualifier("mydbinfo") DataSource dataSource) throws Exception {
        MybatisSqlSessionFactoryBean sessionFactoryBean = new MybatisSqlSessionFactoryBean();
        sessionFactoryBean.setDataSource(dataSource);
        MybatisConfiguration mybatisConfiguration = new MybatisConfiguration();
        mybatisConfiguration.setLogImpl(StdOutImpl.class);
        sessionFactoryBean.setConfiguration(mybatisConfiguration);
        sessionFactoryBean.setMapperLocations(
                new PathMatchingResourcePatternResolver().getResources("classpath*:mapper/mydbinfo/*.xml"));

        return sessionFactoryBean.getObject();
    }

    @Bean("mydbinfoSqlSessionTemplate")
    @Primary
    public SqlSessionTemplate mydbinfoSqlSessionTemplate(
            @Qualifier("mydbinfoSqlSessionFactory") SqlSessionFactory sessionFactory) {
        return new SqlSessionTemplate(sessionFactory);
    }

}
