package com.gyee.clientside.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * 拦截器
 */
@Configuration
public class WebMvcConfig implements  WebMvcConfigurer  {

	/** 解决跨域问题 **/
	@Override
	public void addCorsMappings(CorsRegistry registry){
		// 设置允许跨域的路由
        registry.addMapping("/**")
			// 设置允许跨域请求的域名
			.allowedOriginPatterns("*")
			// 是否允许证书
			.allowCredentials(true)
			// 设置允许的方法
			.allowedMethods("GET", "POST", "DELETE", "PUT")
			// 设置允许的header属性
			.allowedHeaders("*")
				// 跨域允许时间
			.maxAge(3600);
	}

	/*@Override
	public void configureMessageConverters(List<HttpMessageConverter<?>> converters) {
		//解决中文乱码
		StringHttpMessageConverter converter1 = new StringHttpMessageConverter(Charset.forName("UTF-8"));
		converters.add(converter1);
		//解决 添加解决中文乱码后 上述配置之后，返回json数据直接报错 500：no convertter for return value of type
		MappingJackson2HttpMessageConverter converter2 = new MappingJackson2HttpMessageConverter();
		converter2.setObjectMapper(new ObjectMapper());
		converters.add(converter2);
		WebMvcConfigurer.super.configureMessageConverters(converters);
	}*/
}
