package com.gyee.clientside.controller;

import cn.hutool.jwt.JWT;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gyee.clientside.entity.MyUsers;
import com.gyee.clientside.result.Result;
import com.gyee.clientside.result.ResultCode;
import com.gyee.clientside.service.IMyUsersService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.nio.charset.StandardCharsets;
import java.sql.Timestamp;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author gfhd
 * @since 2023-03-29
 */
@RestController
@RequestMapping("/myUsers")
public class MyUsersController {

    @Resource
    private IMyUsersService userService;

    @PostMapping("/login")
    private JSONObject login(@RequestBody Map<String, String> user) {
        String username = user.get("username");
        QueryWrapper<MyUsers> wrapper = new QueryWrapper<>();
        wrapper.eq("username", username);
        MyUsers loginDTO = userService.getOne(wrapper);
        if (loginDTO == null) return Result.error(ResultCode.USER_ACCOUNT_ERROR);
        if (JWT.of(loginDTO.getToken()).verify())
            return Result.successData(loginDTO);
        return Result.error(ResultCode.USER_ACCOUNT_ERROR);
    }

    @PostMapping("/set")
    private void set(@RequestBody Map<String, String> user) {
        MyUsers ld = new MyUsers();
        ld.setId(new Timestamp(System.currentTimeMillis()));
        ld.setUsername(user.get("username"));
        String token = JWT.create().setPayload("username", ld.getUsername())
                .setKey(user.get("password").getBytes(StandardCharsets.UTF_8))
                .sign();
        ld.setToken(token);
        userService.save(ld);
    }

    @GetMapping("/get")
    private JSONObject get(String username) {
        QueryWrapper<MyUsers> wrapper = new QueryWrapper<>();
        wrapper.eq("username", username);
        MyUsers one = userService.getOne(wrapper);
        return Result.successData(one);
    }

    @GetMapping("/create")
    private void create() {
        userService.create();
    }
}
