package com.gyee.clientside.controller;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gyee.clientside.entity.Permissions;
import com.gyee.clientside.result.Result;
import com.gyee.clientside.service.IPermissionsService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.sql.Timestamp;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author gfhd
 * @since 2023-03-29
 */
@RestController
@RequestMapping("/permissions")
public class PermissionsController {

    @Resource
    private IPermissionsService permissionsService;

    @PostMapping("/set")
    private void set(@RequestBody Map<String, String> user) {
        Permissions ld = new Permissions();
        ld.setId(new Timestamp(System.currentTimeMillis()));
        ld.setPermisname(user.get("permisname"));
        permissionsService.save(ld);
    }

    @GetMapping("/get")
    private JSONObject get(String permisname) {
        QueryWrapper<Permissions> wrapper = new QueryWrapper<>();
        wrapper.eq("permisname", permisname);
        Permissions one = permissionsService.getOne(wrapper);
        return Result.successData(one);
    }
}
