package com.gyee.clientside.mapper.master;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gyee.clientside.entity.Point;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

public interface PointMapper extends BaseMapper<Point> {

    @Select("SELECT DISTINCT station FROM #{stbname}")
    List<String> selectStation(String stbname);

    @Select("SELECT table_name FROM INFORMATION_SCHEMA.INS_TABLES where stable_name=#{stablename} limit #{startindex},#{endindex}")
    List<String> selectTableName(@Param("stablename") String stablename, @Param("startindex") int startindex, @Param("endindex") int endindex);

    @Select("SELECT tbname as point,description,ts,val,station,category,facility,uniformcode,rate,remark FROM ${stablename} ${ew.customSqlSegment}")
    List<Point> selectTableNamesPage(IPage<Point> page, @Param("stablename") String stablename, @Param("ew") Wrapper wrapper);

    @Update("DROP TABLE ${tablename}")
    void deleteTable(String tablename);

    @Select("SELECT * FROM ${tablename} ${ew.customSqlSegment}")
    List<Point> selectTableValPage(IPage<Point> page, @Param("tablename") String tablename, @Param("ew") Wrapper wrapper);

    @Update("CREATE STABLE IF NOT EXISTS #{stableName}(ts timestamp,val ${valueType}) TAGS (description nchar(100),station binary(20),category binary(20),facility binary(20),uniformcode binary(20),rate float,remark binary(30))")
    int createSuperTable(@Param("stableName") String stableName, @Param("valueType") String valueType);

    @Update("CREATE TABLE IF NOT EXISTS #{tableName} USING ${stableName} TAGS (${description},${station},${category},${facility},${uniformcode},${rate},${remark})")
    int createTable(@Param("tableName") String tableName, @Param("stableName") String stableName, @Param("description") String description, @Param("station") String station, @Param("category") String category, @Param("facility") String facility, @Param("uniformcode") String uniformcode, @Param("rate") float rate, @Param("remark") String remark);

    @Update("${sql}")
    void runSql(String sql);

    @Update("ALTER TABLE ${tableName} SET TAG ${tagName}='${tagValue}'")
    void alterTag(@Param("tableName") String tableName, @Param("tagName") String tagName, @Param("tagValue") String tagValue);

    @Update("ALTER TABLE ${tableName} SET TAG ${tagName}=${tagValue}")
    void alterTagNum(@Param("tableName") String tableName, @Param("tagName") String tagName, @Param("tagValue") Float tagValue);
}
