package com.gyee.clientside.mapper.vacant;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gyee.clientside.entity.Point;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;

import java.sql.Timestamp;

public interface PointDBMapper extends BaseMapper<Point> {

    @Update("CREATE DATABASE IF NOT EXISTS ${dbname} ${ew.customSqlSegment}")
    int createDataBase(String dbname, @Param("ew") Wrapper wrapper);

    @Update("CREATE TABLE IF NOT EXISTS #{tbName} USING #{stbName} TAGS(#{description},#{station},#{category},#{equipment},#{uniformcode},#{rate},#{remark})")
    int createTable(@Param("tbName") String tbName, @Param("stbName") String stbName, @Param("description") String description, @Param("station") String station, @Param("category") String category, @Param("equipment") String equipment, @Param("uniformcode") String uniformcode, @Param("rate") float rate, @Param("remark") String remark);

    @Update("DROP TABLE IF EXISTS #{tbname}")
    void dropTable(String tbname);

    @Insert("INSERT INTO #{tbname}(ts, val) values(#{ts}, #{val})")
    int insertOne(@Param("tbname") String tbname, @Param("ts") Timestamp ts, @Param("val") Double val);

    @Update("ALTER TABLE #{point} SET TAG description=#{description},station=#{station},category=#{category},equipment=#{equipment},uniformcode=#{uniformcode},rate=#{rate},remark=#{remark}")
        //int alterTags(@Param("tbName") String tbName, @Param("description") String description, @Param("station") String station, @Param("category") String category, @Param("equipment") String equipment, @Param("uniformcode") String uniformcode, @Param("rate") float rate, @Param("remark") String remark);
    int alterTags(Point entity);

}
