package com.gyee.clientside.result;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.io.Serializable;

@Data
public class Result implements Serializable {

    private Integer code;
    private String message;
    private Object data;

    public static JSONObject error() {
        JSONObject json = new JSONObject();
        json.put("code", ResultCode.ERROR.getCode());
        json.put("msg", ResultCode.ERROR.getMessage());
        return json;
    }

    public static JSONObject error(ResultCode resultCode) {
        JSONObject json = new JSONObject();
        json.put("code", resultCode.getCode());
        json.put("msg", resultCode.getMessage());
        return json;
    }

    public static JSONObject error(ResultCode resultCode, String message) {
        JSONObject json = new JSONObject();
        json.put("code", resultCode.getCode());
        json.put("msg", resultCode.getMessage() + "," + message);
        return json;
    }

    public static JSONObject error(int code, String message) {
        JSONObject json = new JSONObject();
        json.put("code", code);
        json.put("msg", message);
        return json;
    }

    public static JSONObject success() {
        JSONObject json = new JSONObject();
        json.put("code", ResultCode.SUCCESS.getCode());
        json.put("msg", ResultCode.SUCCESS.getMessage());
        return json;
    }

    public static JSONObject seccess(int code, String message) {
        JSONObject json = new JSONObject();
        json.put("code", code);
        json.put("msg", message);
        return json;
    }

    public static JSONObject seccess(String message) {
        JSONObject json = new JSONObject();
        json.put("code", 200);
        json.put("msg", message);
        return json;
    }

    public static JSONObject success(ResultCode resultCode) {
        JSONObject json = new JSONObject();
        json.put("code", resultCode.getCode());
        json.put("msg", resultCode.getMessage());
        return json;
    }

    public static JSONObject successData(ResultCode code, Object data) {
        JSONObject json = new JSONObject();
        json.put("code", code.getCode());
        json.put("msg", code.getMessage());
        json.put("data", data == null ? new JSONObject() : data);
        return json;
    }

    public static JSONObject successData(Object data) {
        JSONObject json = new JSONObject();
        json.put("code", 200);
        json.put("data", data == null ? new JSONObject() : data);
        return json;
    }
}
