package com.gyee.redisread.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.JedisPoolConfig;

@Component
public class RedisConfig {
    @Value("${redis.host:127.0.0.1}")
    private String host;
    @Value("${redis.port:6379}")
    private Integer port;
    @Value("${redis.password:}")
    private String password;

    @Value("${taoswrite.urls}")
    private String taosUrls;

    private JedisPool jedisPool;

    public Jedis getJedis() {
        if (jedisPool == null) {
            JedisPoolConfig jedisPoolConfig = new JedisPoolConfig();
            // 最大连接
            jedisPoolConfig.setMaxTotal(32);
            // 最大空闲连接
            jedisPoolConfig.setMaxIdle(64);
            // 最小空闲连接
            jedisPoolConfig.setMinIdle(0);
            if ("".equals(password)) {
                jedisPool = new JedisPool(jedisPoolConfig, host, port, 5000);
            } else {
                jedisPool = new JedisPool(jedisPoolConfig, host, port, 5000, password);
            }
        }
        return jedisPool.getResource();
    }

    public String getTaosUrls() {
        if (taosUrls == null) {
            taosUrls = "";
        }
        return taosUrls;
    }
}
