package com.gyee.redisread.controller;

import com.gyee.redisread.service.ReadRedisService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@Slf4j
@RestController
@RequestMapping("/redis")
public class RedisController {

    @Resource
    private ReadRedisService readRedisService;


    @GetMapping("/read/start")
    private boolean taos2RedisStart() {
        return readRedisService.start();
    }

    @GetMapping("/read/stop")
    private boolean taos2RedisStop() {
        return readRedisService.stop();
    }

    @GetMapping("/read/status")
    private boolean taos2RedisStatus() {
        return readRedisService.isActive();
    }

    @GetMapping("/aikeys")
    private List<String> getAIKeys() {
        return readRedisService.getAikeys();
    }

    @GetMapping("/dikeys")
    private List<String> getDIKeys() {
        return readRedisService.getDikeys();
    }

    @GetMapping("/size/aipoint")
    private int getAiPoint() {
        return readRedisService.getAikeys().size();
    }

    @GetMapping("/size/dipoint")
    private int getDiPoint() {
        return readRedisService.getDikeys().size();
    }
}
