package com.gyee.taoswrite.controller;

import com.gyee.taoswrite.mapper.PointMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Slf4j
@RestController
public class TaosWriteController {

    @Resource
    private PointMapper pointMapper;

    @Value("${taoscz.ai_stable_name:pointai}")
    private String aidbname;
    @Value("${taoscz.di_stable_name:pointdi}")
    private String didbname;

    @PostMapping("/write")
    private void taos2RedisStart(@RequestBody String sql) {

        try {
            pointMapper.insert(sql);
            System.out.print("*");
        } catch (Exception e) {
            e.printStackTrace();

            String ss;
            if (sql.contains("DI") || sql.contains("di")) {
                ss = sql.replace("VALUES", "USING " + didbname + " TAGS('','','','','',1,'') VALUES");
            } else {
                ss = sql.replace("VALUES", "USING " + aidbname + " TAGS('','','','','',1,'') VALUES");
            }

            try {
                pointMapper.insert(ss);
            } catch (Exception ex) {
                ex.printStackTrace();
                log.error(ss);
            }
        }

    }
}
